<script setup>
import { computed } from "vue";
import { useStore } from "vuex";
import PluginSettings from "@components/Game/PluginSettings.vue";
// import Prompt from "@components/Template/Prompt.vue";

// Connect to Store and Router
const store = useStore();

// Compute necessary Store values for Component
const game = computed(() => store.state.game.selected);
const setupData = computed(() => store.state.game.setup);

function openTab(e, tabName, ref) {
  // hide everything
  const links = document.querySelectorAll("li.tab-link:not(.dashboard)");
  const tabs = document.querySelectorAll("div.tab-content:not(.dashboard)");
  Array.from(links).forEach((node) => node.classList.remove("is-active"));
  Array.from(tabs).forEach((node) => node.classList.add("is-hidden"));
  // show selection
  document.getElementById(tabName).classList.remove("is-hidden");
  e.currentTarget.classList.add("is-active");
  // ececute child on visible function
  if (ref && Object.prototype.hasOwnProperty.call(ref, "onVisible")) ref.onVisible();
}
</script>

<template>
  <div class="is-clipped-container is-flex is-flex-direction-column has-background-purple-5 px-2">
    <h1 class="title is-5">Settings {{ game }}</h1>
    <div class="tabs">
      <ul>
        <li class="tab-link is-active" @click="openTab($event, 'tab_plugins', $refs.pluginComponent)">
          <a>PLUGINS</a>
        </li>
        <li class="tab-link" @click="openTab($event, 'tab_setup')">
          <a>SETUP</a>
        </li>
      </ul>
    </div>
    <div class="tab-container is-scroll-container">
      <div id="tab_plugins" class="tab-content">
        <PluginSettings ref="pluginComponent" />
      </div>
      <div id="tab_setup" class="tab-content is-hidden">
        <div>{{ setupData }}</div>
      </div>
    </div>
    <!-- <Prompt /> -->
  </div>
</template>
